LibreOffice: cppu::OComponentHelper Class Reference

LibreOffice LibreOffice 6.3 SDK C/C++ API Reference

Public Member Functions | Protected Member Functions | List of all members
cppu::OComponentHelper Class Referenceabstract

Deprecated. More...

`#include <component.hxx>`

Inheritance diagram for cppu::OComponentHelper:

## Public Member Functions
| OComponentHelper (::osl::Mutex &rMutex)
| Constructor. More...
virtual | ~OComponentHelper () SAL_OVERRIDE
| Destructor. More...
virtual css::uno::Any | queryInterface (css::uno::Type const &rType) SAL_OVERRIDE
| If a delegator is set, then the delegator is queried for the demanded interface. More...
virtual css::uno::Any | queryAggregation (css::uno::Type const &rType) SAL_OVERRIDE
| Called by the delegator or queryInterface. More...
virtual void | acquire () SAL_OVERRIDE throw ()
| If a delegator is set, then the delegators gets acquired. More...
virtual void | release () SAL_OVERRIDE throw ()
| If a delegator is set, then the delegators gets released. More...
virtual css::uno::Sequence< sal_Int8 > | getImplementationId () SAL_OVERRIDE=0
virtual css::uno::Sequence< css::uno::Type > | getTypes () SAL_OVERRIDE
virtual void | dispose () SAL_OVERRIDE
virtual void | addEventListener (const css::uno::Reference< css::lang::XEventListener > &aListener) SAL_OVERRIDE
virtual void | removeEventListener (const css::uno::Reference< css::lang::XEventListener > &aListener) SAL_OVERRIDE
Public Member Functions inherited from cppu::OWeakAggObject
| OWeakAggObject ()
| Constructor. More...
virtual void | setDelegator (const css::uno::Reference< css::uno::XInterface > &Delegator) SAL_OVERRIDE
| Set the delegator. More...
Public Member Functions inherited from cppu::OWeakObject
| OWeakObject ()
| Default Constructor. More...
| OWeakObject (const OWeakObject &)
| Dummy copy constructor. More...
OWeakObject & | operator= (const OWeakObject &)
| Dummy assignment operator. More...
virtual css::uno::Reference< css::uno::XAdapter > | queryAdapter () SAL_OVERRIDE
| XWeak::queryAdapter() implementation. More...
| operator css::uno::Reference< css::uno::XInterface > ()
| Cast operator to XInterface reference. More...

## Protected Member Functions
virtual void | disposing ()
| Called in dispose method after the listeners were notified. More...
Protected Member Functions inherited from cppu::OWeakAggObject
virtual | ~OWeakAggObject () SAL_OVERRIDE
| Virtual dtor. More...
Protected Member Functions inherited from cppu::OWeakObject
virtual | ~OWeakObject () COVERITY_NOEXCEPT_FALSE
| Virtual dtor. More...
void | disposeWeakConnectionPoint ()
| disposes and resets m_pWeakConnectionPoint More...

## Additional Inherited Members
Protected Attributes inherited from cppu::OWeakAggObject
css::uno::WeakReferenceHelper | xDelegator
| weak reference to delegator. More...
Protected Attributes inherited from cppu::OWeakObject
oslInterlockedCount | m_refCount
| reference count. More...

## Detailed Description

Deprecated.

Helper for implementing css::lang::XComponent. Upon disposing objects of this class, sub-classes receive a disposing() call. Objects of this class can be held weakly, i.e. by a css::uno::WeakReference. Object of this class can be aggregated, i.e. incoming queryInterface() calls are delegated.

Attention
  The life-cycle of the passed mutex reference has to be longer than objects of this class.

Deprecated:

## Constructor & Destructor Documentation

## ◆ OComponentHelper()

cppu::OComponentHelper::OComponentHelper | ( | ::osl::Mutex & | rMutex | ) |

Constructor.

Parameters

  rMutex | the mutex used to protect multi-threaded access; lifetime must be longer than the lifetime of this object.

## ◆ ~OComponentHelper()

virtual cppu::OComponentHelper::~OComponentHelper | ( |  | ) |
| virtual

Destructor.

If this object was not disposed previously, object will be disposed manually.

## Member Function Documentation

## ◆ acquire()

virtual void cppu::OComponentHelper::acquire | ( |  | ) |
throw | ( |
| ) |  |
| virtual

If a delegator is set, then the delegators gets acquired.

Otherwise call is delegated to base class cppu::OWeakObject.

Reimplemented from cppu::OWeakAggObject.

## ◆ addEventListener()

virtual void cppu::OComponentHelper::addEventListener | ( | const css::uno::Reference< css::lang::XEventListener > & | aListener | ) |
| virtual

## ◆ dispose()

virtual void cppu::OComponentHelper::dispose | ( |  | ) |
| virtual

## ◆ disposing()

virtual void cppu::OComponentHelper::disposing | ( |  | ) |
| protectedvirtual

Called in dispose method after the listeners were notified.

## ◆ getImplementationId()

virtual css::uno::Sequence< sal_Int8 > cppu::OComponentHelper::getImplementationId | ( |  | ) |
| pure virtual

Attention
  XTypeProvider::getImplementationId() has to be implemented separately!

## ◆ getTypes()

virtual css::uno::Sequence< css::uno::Type > cppu::OComponentHelper::getTypes | ( |  | ) |
| virtual

Attention
  XTypeProvider::getTypes() has to be re-implemented!

## ◆ queryAggregation()

virtual css::uno::Any cppu::OComponentHelper::queryAggregation | ( | css::uno::Type const & | rType | ) |
| virtual

Called by the delegator or queryInterface.

Re-implement this method instead of queryInterface.

See also
  queryInterface

Reimplemented from cppu::OWeakAggObject.

## ◆ queryInterface()

virtual css::uno::Any cppu::OComponentHelper::queryInterface | ( | css::uno::Type const & | rType | ) |
| virtual

If a delegator is set, then the delegator is queried for the demanded interface.

If the delegator cannot provide the demanded interface, it calls queryAggregation() on its aggregated objects.

Parameters

  rType | demanded interface type

Returns
  demanded type or empty any

See also
  queryAggregation.

Reimplemented from cppu::OWeakAggObject.

## ◆ release()

virtual void cppu::OComponentHelper::release | ( |  | ) |
throw | ( |
| ) |  |
| virtual

If a delegator is set, then the delegators gets released.

Otherwise call is delegated to base class cppu::OWeakObject.

Reimplemented from cppu::OWeakAggObject.

## ◆ removeEventListener()

virtual void cppu::OComponentHelper::removeEventListener | ( | const css::uno::Reference< css::lang::XEventListener > & | aListener | ) |
| virtual

The documentation for this class was generated from the following file:

- cppuhelper/component.hxx